#!/usr/bin/python
import sys

def writeStream(f, data):
  for l in data:
    f.write(chr(l))

def get_reg_list(data, reg):
  outdata = []
  for l in data:
    p=l.split()
    try:
      v=int(p[reg])
    except:
      v=0xff
    outdata.append(v)
  return outdata

def writeNt(f, v):
  f.write(v.strip())
  f.write(chr(0))

def writeShort(f, v):
  f.write(chr((v>>8) % 256))
  f.write(chr(v % 256))

def writeWord(f, v):
  f.write(chr((v>>24) % 256))
  f.write(chr((v>>16) % 256))
  f.write(chr((v>>8) % 256))
  f.write(chr(v % 256))

outfile=open(sys.argv[2], "wb")
l=open(sys.argv[1],"rt").readlines()

all_ay=[]


framecount=len(l)
print framecount,"frames"

outfile.write("YM6!LeOnArD!")
# frames
writeWord(outfile, framecount)
# attributes - set to 1 for interleaved, which is generally how it is done
writeWord(outfile, 1)
# digis
writeShort(outfile, 0)
# clock
# workaround: set to 1000000 for ymcruncher :)
#writeWord(outfile, 1500000)
writeWord(outfile, 1000000)
# player
writeShort(outfile, int(sys.argv[3]))
# loop
writeWord(outfile, 0)
# extradata
writeShort(outfile, 0)
# title
writeNt(outfile, "title")
writeNt(outfile, "author")
writeNt(outfile, "commant")

for r in range(16):
  all_ay.append(get_reg_list(l, r))

"""
# Re-order to frequency, to see if that helps our optimization...
for l in range(len(all_ay[0])):
  print '-----------------------------------------------------------'
  frqs=[
    all_ay[0][l]+all_ay[1][l]*256,
    all_ay[2][l]+all_ay[3][l]*256,
    all_ay[4][l]+all_ay[5][l]*256]
  order=[0,1,2]
  out_order = [x for _,x in sorted(zip(frqs,order))]
  new_ay=[]
  for r in range(14):
    new_ay.append(all_ay[r][l])
  print new_ay
  for c in range(3):
    n = out_order[c]
    # freq
    new_ay[c*2]=all_ay[n*2][l]
    new_ay[c*2+1]=all_ay[n*2+1][l]
    # vol
    new_ay[8+c]=all_ay[8+n][l]
    # type
    new_ay[7] = new_ay[7] & (0xff ^ (9<<c))
    new_ay[7] = new_ay[7] | (((all_ay[7][l] >> n) & 9) << c)

  for r in range(14):
    all_ay[r][l] = new_ay[r]
  print out_order
  print new_ay
"""

for r in range(16):
  writeStream(outfile, all_ay[r])

outfile.write("End!")
